Package 2048 - Projet informatique de 1er semestre ENSAE
========================================================

Ce module propose une fonction pour rsoudre le 2048.
La fonction snake_strategy rsout le 2048 en utilisant la stratgie du snake.
Afin de juger l'efficacit de cet algorithme, vous pouvez utiliser la fonction evaluate_strategy 
qui prend en argument la fonction snake_strategy et le nombre de parties effectues.

Comment notre programme rsout-il le 2048 ?
-------------------------------------------
La fonction snake_strategy prend en argument la grille de 2048 et les trois derniers mouvements effectus.
Elle renvoie une direction de jeu en accord avec le principe du programme qui suit.
L'ide est d'agencer les cases de manire dcroissante, de faon  organiser un "snake" pour faciliter le repli de toutes ces cases.
En favorisant la fusion sur une mme ligne ou  partir d'une ligne suprieure, notre algorithme assouplit le principe du snake.
A partir du score de 512, le programme accorde une grande importance au nombre de zros prsents dans le jeu, pour viter  tout prix la fin du jeu.
De plus, il essaie de prvoir cinq coups en avance afin de maximiser son score.

La fonction evaluate_strategy permet d'valuer une stratgie de jeu.
Pour cela, elle effectue le nombre de parties donn en argument et renvoie un gnrateur.
Pour chaque partie, la grille de 2048 est initialise, puis une direction est choisie grce  la stratgie donne en argument.
La grille est alors mise  jour en effectuant un mouvement selon cette direction, et simultanment de nouveaux 2 ou 4 sont gnrs dans la grille.
Si la grille arrive en situation de gameover, la partie se termine.


Quels tests avons nous programm pour nos fonctions ?
-----------------------------------------------------

Le test test_game_play permet de vrifier si la grille de 2048 ragit correctement  l'annonce d'une direction.

Le test test_basic permet de vrifier que la direction renvoye par la stratgie snake_stratgie est bien un lment de {0, 1, 2, 3}.

Le test test_advanced permet de vrifier la cohrence de l'volution de la grille de 2048 avec la stratgie snake_stratgie. 
Il se place dans le cas o l'algorithme n'effectue aucune prvision sur les prochains tours.
Il s'intresse particulirement au choix d'effectuer une fusion ou de favoriser une certaine direction.

Quelques commandes utiles.
--------------------------

Ce module peut tre install avec pip :

    pip install pack2048

Exemple d'usage :

    >>> from pack2048 import evaluate_strategy, snake_strategy
    >>> evaluate_strategy(snake_strategy,10)

Les tests doivent tre effectus en console  l'aide de la commande suivante :

    python -m pack2048

Si vous souhaitez davantages de dtails sur les tests, utilisez la commande suivante :

    python -m pack2048 -v

Ce code est sous licence GNU AGPLv3.